% -------------------------------------------------------------------------
% create figures Data section
% -------------------------------------------------------------------------
clear;
load('DatasetNew.mat');
% -------------------------------------------------------------------------
% Include table EST: min median mean max spells and same for TOTAL
% rows destination and final row across all holidays
% include all in appendix and final row in main paper
Ydestd = dummyvar(Ydest);
Table = zeros(49,8);
for j=1:49
    est = HL(Ydestd(:,j)==1);
    tot = Rdura(Ydestdum(:,j)==1);
    Table(j,:) = [min(tot) median(tot) mean(tot) max(tot)...
                  min(est) median(est) mean(est) max(est)];
end
Table = [Table;[min(Rdura) median(Rdura) mean(Rdura) max(Rdura)...
                  min(HL) median(HL) mean(HL) max(HL)]];
% -------------------------------------------------------------------------
% barplot y
Ydum = dummyvar(Ydest);
[J,N]       = size(Ydum');
freqy = sum(Ydum);
hb1 = figure; bar(freqy,'k'); ylim([0 850]);
for i=1:J
    text(i,freqy(i),num2str(freqy(i)),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom');
end
ax1=gca;
set(ax1,'xtick',1:J,'xticklabel',rc(1).catsr,'Ticklength', [0 0])
xtickangle(45)
ax2 = axes('Position',get(ax1, 'Position'),...
    'XAxisLocation','top',...
    'YAxisLocation','right',...
    'Color','none');
set(ax2,'xlim',[0 J+1],'xtick',1:J,'YTickLabel',[],'ytick',[]);
set(hb1, 'Position', [40 100 1600 400]);
% -------------------------------------------------------------------------
% #observations per household
% a=tabulate(Hresp);
% a(a(:,2)==0,:)=[];
% obs_per_hh = sum(dummyvar(a(:,2)));
% -------------------------------------------------------------------------
% barplot dummies
fs=15;
xcatall     = [X(:,11:20) 1-sum(X(:,11:20),2)];
Kd          = size(xcatall,2);
dnames = {'single <35','single >=35','kids 0-5','kids 6-12','kids 13-17','kids 0-5, 6-12',...
    'kids 0-5, 13-17','kids 6-12, 13-17','kids 0-5, 6-12, 13-17','hh>1, head<35','hh>1, head>=35'};
freqd=sum(xcatall);
hb2 = figure; bar(freqd,'k'); axd1 = gca; set(axd1,'xtick',1:Kd,'xticklabel',dnames,'Ticklength', [0 0],'FontSize',fs);
for i=1:Kd
    text(i,freqd(i),num2str(freqd(i)),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom');
end
xtickangle(45)
axd2 = axes('Position',get(axd1, 'Position'),...
    'XAxisLocation','top',...
    'YAxisLocation','right',...
    'Color','none');
set(axd2,'xlim',[0 Kd+1],'xtick',1:Kd,'YTickLabel',[],'ytick',[],'FontSize',fs);

set(hb2, 'Position', [40 100 1600 400]);

% barplot controls
fs=15;
xfall       = [X(:,[1 3:10])];
Kw          = size(xfall,2);
    Kd          = size(xcatall,2);
    K           = Kw+Kd;
dnames = {'retired','student','moving accomodation','fixed accomodation','social class B1',...
    'social class B2','social class C','social class D'};
freqd= sum(xfall(:,2:end));
hb2 = figure; bar(freqd,'k'); axd1 = gca; set(axd1,'ylim',[0 2200],'xtick',1:(Kw-1),'xticklabel',dnames,'Ticklength', [0 0],'FontSize',fs);
for i=1:(Kw-1)
    text(i,freqd(i),num2str(freqd(i)),...
               'HorizontalAlignment','center',...
               'VerticalAlignment','bottom');
end
xtickangle(45)
% axd2 = axes('Position',get(axd1, 'Position'),...
%     'XAxisLocation','top',...
%     'YAxisLocation','right',...
%     'Color','none');
% set(axd2,'ylim',[0 2500],'xlim',[0 Kw],'xtick',1:(Kw-1),'YTickLabel',[],'ytick',[],'FontSize',fs);

set(hb2, 'Position', [40 100 1600 400]);