% -------------------------------------------------------------------------
% function that calculates loglik per cluster and per dummy
% -------------------------------------------------------------------------
function F = MNLlld(Y,X,alpha,beta,betaLd,Kw)
% -------------------------------------------------------------------------
Xd      = X(:,Kw+1:end);
Kd      = size(Xd,2);
Ld      = size(betaLd,1);
F       = zeros(Kd,Ld);
axb     = X*beta+alpha';
exp_axb = exp(axb);
%
YXd     = Y'*Xd;
exp_Xd  = exp(Xd);
indD    = Xd~=0;
l1s     = sum(sum(Y.*axb));
l2p      = log(sum(exp_axb,2));
l2s     = sum(l2p);
% -------------------------------------------------------------------------
for l=1:Ld
    betal = betaLd(l,:);
    for k=1:Kd
        betak  = beta(Kw+k,:);
        dbeta  = betal-betak;
        if sum(dbeta)==0
            l1 = l1s;
            l2 = l2s;
        else
            l1                   = l1s+dbeta*YXd(:,k);
            l2o = l2p;
            indDk = indD(:,k);
            A = exp_axb(indDk,:).*exp(dbeta);
            l2o(indDk,:)         = log(sum(A,2));
            l2 = sum(l2o);
        end
        F(k,l) = l1-l2;
    end
end
% -------------------------------------------------------------------------
end