% -------------------------------------------------------------------------
function [alpha,betacd] = MNLpgNEW(Y,indexb,X,XL,alpha,beta,v,C,wD,L)
% -------------------------------------------------------------------------
% INPUT: N*J matrix Y=dummyvar(y)
%        N*K matrix X
% -------------------------------------------------------------------------
betacd = zeros(length(indexb),L);
J      = size(beta,2);
K      = size(XL,2);
cats   = 2:J;
%
obs1   = Y(:,1)==1;
Ym     = Y(:,2:end);
xb     = X*beta+alpha';
% -------------------------------------------------------------------------
for l=1:L
    indexl = C==l;
    numl   = sum(indexl);
    % ---------------------------------------------------------------------
    if numl>0
        % take observations cluster l and observations cluster 1
        obsl                       = (sum(Ym(:,indexl),2))==1;
        Nl                         = sum(obsl)+numl*sum(obs1);
        catl                       = cats(indexl);
        Z                          = zeros(Nl,K+numl);
        Kap                        = zeros(Nl,1);
        W                          = zeros(Nl,1);
        st                         = 1;
        % sample w
        for i=1:numl
            j                      = catl(i);
            obsi                   = (Y(:,j)+obs1)==1;
            Wj                     = pgdraw(xb(obsi,j));
            itc                    = zeros(sum(obsi),numl);
            itc(:,i)               = 1;
            Zj                     = [itc XL(obsi,:)];
            Kapj                   = Y(obsi,j)-0.5;
            W(st:st+sum(obsi)-1)   = Wj;
            Z(st:st+sum(obsi)-1,:) = Zj;
            Kap(st:st+sum(obsi)-1) = Kapj;
            st                     = st+sum(obsi);
        end
        %%%
        betal = zeros(length(indexb),1);
        if l>1       %Z'*diag(W)*Z
            V                      = inv(((Z.*W)'*Z)+(1/v)*eye(numl+K));
            m                      = V*(Z'*Kap);
            est                    = m + chol(V)'*randn(K+numl,1);
            alphal                 = est(1:numl);
            betal(indexb==1)       = est(numl+1:end);
            betal(indexb==0)       = sqrt(1)*randn(sum(indexb==0),1);
        else
            Z                      = Z(:,1:numl);
            V                      = inv(((Z.*W)'*Z)+(1/v)*eye(numl));
            m                      = V*(Z'*Kap);
            alphal                 = m + chol(V)'*randn(numl,1);
        end
        %%%
    elseif l>1
        % sample beta for empty D clusters
        betal                      = zeros(length(indexb),1);
        betal(indexb==1)           = sqrt(v)*randn(sum(indexb==1),1);
        alphal                     = [];
        betal(indexb==0)           = sqrt(v)*randn(sum(indexb==0),1);
    else
        betal                      = zeros(length(indexb),1);
        alphal                     = [];
    end
    % ---------------------------------------------------------------------
    indexl0                        = [0; indexl]==1;
    alpha(indexl0)                 = alphal;
    betacd(:,l)                    = betal;
    betac                          = betal(wD);
    beta(:,indexl0)                = repmat(betac,1,numl);
    xb(:,indexl0)                  = X*betac+alpha(indexl0)';
    % ---------------------------------------------------------------------
end
% -------------------------------------------------------------------------
end