% -------------------------------------------------------------------------
% function that constructs X from clustered dummies
% note that we have category specific intercept.
% so we can only include K-1 dummies
% and dummies should be able have same effect as intercept: coef=0.
% -------------------------------------------------------------------------
function [Xcluster,indexd] = clusterX(Xcats,D,L)
% -------------------------------------------------------------------------
% L = number of clusters
% D is K*1 classification vector, with K is number of categories
% do not include categories with D=1 in Xcluster - same effect as intercept
% -------------------------------------------------------------------------
N         = size(Xcats,1);
Xcluster  = zeros(N,L);
indexd    = zeros(L,1);
indexd(1) = -1;
for l=2:L
    indexl = D==l;
    numl   = sum(indexl);
    if numl>0
        Xcluster(:,l) = sum(Xcats(:,indexl),2);
        indexd(l,1)   = 1;
    end
end
Xcluster(:,indexd~=1) = [];
% -------------------------------------------------------------------------
end