function [Ind,P,Px,alpha] = sampleInd(F,P,alpha,prior)
% -------------------------------------------------------------------------
% input: if first index is fixed cluster: input F(2:end,:) and add first
% row to output Ind and P
% -------------------------------------------------------------------------
[J,L] = size(F);
Ind   = zeros(J,1);
Px    = zeros(J,L);
r     = zeros(L,1);
% -------------------------------------------------------------------------
%  r, alpha, P, prior
% -------------------------------------------------------------------------
for j=1:J
    % Choose M to be the element of Fj that is largest in absolute value.
%     [~,m]        = max((F(j,:))); 
%     M            = F(j,m);
%     pij          = P'.*exp(F(j,:)-M);
%     regimep      = pij/sum(pij);
%     regime       = 1+sum(rand>=cumsum(regimep));
%%%
% https://stats.stackexchange.com/questions/64081/how-do-i-sample-from-a-discrete-categorical-distribution-in-log-space
g = -log(-log(rand(1,L)));  
d = F(j,:) +log(P') + g;
[~,regime] = max(d);
%
    Ind(j)       = regime;
    r(regime)    = r(regime)+1;
    %Px(j,:)      = regimep;
end
% -------------------------------------------------------------------------
% L, r, alpha, P, prior
% -------------------------------------------------------------------------
V = zeros(L-1,1);
for i=1:L-1
    V(i,1) = betarnd(1+r(i,1),alpha+sum(r((i+1):end,1)));
    if i==1
        P(i,1) = V(i,1);
    else
        P(i,1) = prod((1-V(1:i-1,1)))*V(i,1);
    end
end
P(L,:)  = 1-sum(P(1:L-1,:));
alpha   = gamrnd(L+prior.eta1-1,1/(prior.eta2-sum(log(1-V))));
% -------------------------------------------------------------------------
end