
function [hr,ls,Ypred,prob] = statPredictive(Y,X,alphGibbs,betaGibbs)

[N,J] = size(Y);
nSamples = size(betaGibbs,3);

prob   = zeros(N,J);
expXB  = ones(1,J);

for i=1:N
    ydensi  = zeros(1,J);
    Xi      = X(i,:);
    for g=1:nSamples
        expXB(2:J)  = exp(alphGibbs(:,g)'+Xi*betaGibbs(:,:,g));
        probig      = expXB/sum(expXB,2);
        yig         = 1+sum(rand>=cumsum(probig));
        ydensi(yig) = ydensi(yig) + (1/nSamples);
    end
    prob(i,:) = ydensi;
end

[~,Ypred] = max(prob,[],2);
Ycat      = J+1-sum(cumsum(Y,2),2);
hr        = mean(Ypred==Ycat);

probls = prob;
probls(probls<eps)=eps;
ls  = sum(sum(Y.*log(probls),2))/N;

end
