    
function [logst] = unsStirling1(n,k)
%Computes log unsigned Stirling numbers of the first kind
S      = zeros(n,n);
S(1,1) = 1/k;
for j = 2:n;
    S(1,j) = (j-1)*S(1,j-1);
    for i=2:n;
        S(i,j) = (j-1)*S(i,j-1) + S(i-1,j-1);
    end;
    S(:,j) = S(:,j)/k;
end;
logst = log(S(:,n))+n*log(k);
end