% -------------------------------------------------------------------------
% function that calculates loglik per cluster and per dummy
% -------------------------------------------------------------------------
function F = MNLlld(Y,X,alpha,beta,betaLd,Kw)
% -------------------------------------------------------------------------
Xd      = X(:,Kw+1:end);
Kd      = size(Xd,2);
Ld      = size(betaLd,1);
F       = zeros(Kd,Ld);
axb     = X*beta+alpha;
exp_axb = exp(axb); %slow
% -------------------------------------------------------------------------
YXd     = Y'*Xd; % take out function
indD    = Xd~=0; % take out function
l1s     = sum(sum(Y.*axb));
l2p     = log(1+sum(exp_axb,2)); %slow
l2s     = sum(l2p);
% -------------------------------------------------------------------------
for k=1:Kd
    betak  = beta(Kw+k,:);
    YXdk   = YXd(:,k);
    indDk  = indD(:,k); %slow
    Ak     = exp_axb(indDk,:);
    sk     = ~indDk'*l2p;
    for l=1:Ld
        betal = betaLd(l,:);
        dbeta = betal-betak;
        if sum(dbeta)==0
            l1 = l1s;
            l2 = l2s;
        else
            l1 = l1s+dbeta*YXdk;
            l2 = sk+sum(log(1+sum(Ak.*exp(dbeta),2)),1);
        end
        F(k,l) = l1-l2;
    end
end
% -------------------------------------------------------------------------
end
% -------------------------------------------------------------------------