%--------------------------------------------------------------------------
clear;
rng(12345); 
N = 1000;
[alphadgp,betadgp,qdgp,Qdgp,nudgp,Xw,Xd,X,Y,W,Yout,Xout,Wout] = generate_data(N);
[K,J] = size(betadgp);
[NT,Kd] = size(Xd);
Kw = K-Kd;
T =NT/N;
%--------------------------------------------------------------------------
% prior
%--------------------------------------------------------------------------
% prior beta_jk ~ N(0,(1/v)*I)
v        = 1;
% dpm prior J
Lc             = 10;%25;
modeLc         = 5;%15;
lambdac        = smoothparam(modeLc,J-1);
priorc.eta2    = 2;%20;
priorc.eta1    = lambdac*priorc.eta2;
[lambdac,Pc,Jind] = priordraw(priorc,J-1,Lc);
% Pc            = ones(Lc,1)/Lc;
% Jind          = [1:J-1]';%randi(Lc,J-1,1);
%  [Ec,Vc,pc]    = alpha2num(priorc,J,Lc,10000);
%  figure; bar(pc);
% dpm prior Kd
Ld            = Kd+1;
modeLd        = 5;
lambdad       = smoothparam(modeLd,Kd);
priord.eta2   = 1; 
priord.eta1   = lambdad*priord.eta2;
[lambdad,Pd,Dind] = priordraw(priord,Kd,Ld);
wD                = [(1:Kw) (Kw+Dind')];
[Xl,indexwd,Xind] = clusterX(Xw,Xd,Dind,Ld);
%[Ed,Vd,pd]    = alpha2num(priord,Kd+1,Ld,10000);
%   figure; bar(pd)
% prior RE
Bmu = 1;
a0  = 10*ones(J-1,1);
b0  = 1*ones(J-1,1);
%--------------------------------------------------------------------------
% settings sampler
burnin       = 500000;
nSamples     = 10000;
thin         = 50;
nGibbs       = burnin+nSamples*thin;
saveIndex    = 0;
%--------------------------------------------------------------------------
% initialize sampler
%--------------------------------------------------------------------------
% parameters
alpha  = zeros(J-1,1)';
betacd = zeros(Lc,Kw+Ld);
q      = zeros(J-1,1);
Q      = eye(J-1);
Lambda = zeros(J-1,1);
invpsi = ones(J-1,1);    
nu     = zeros(J-1,N); 
nuT    = repelem(nu',T,1);
nuN    = W.*nuT;
% precalculate quantities
Y2    = Y(:,2:end);
kappa = Y2-0.5;
xx    = zeros(NT,K*K);
for i=1:NT
    xxi     = X(i,:)'*X(i,:);
    xx(i,:) = xxi(:)';
end
Xt      = X';
Xtkappa = Xt*kappa;
beta    = zeros(J-1,K);%betadgp;%
xbeta   = X*beta';
%--------------------------------------------------------------------------
% storage samples
asave = zeros(J-1,nSamples);
bsave = zeros(J-1,K,nSamples);
Csave = zeros(J-1,nSamples);
Dsave = zeros(Kd,nSamples);
qsave = zeros(J-1,nSamples);
Qsave = zeros(J-1,J-1,nSamples);
nsave = zeros(N,J-1,nSamples);
%--------------------------------------------------------------------------
% run sampler
startGibbs=tic;
for iter = 1:nGibbs
    %----------------------------------------------------------------------
    % draw latents
    anu    = alpha+nuN;
    axbeta = anu+xbeta;
    exb    = exp(axbeta);
    sexb   = 1+sum(exb,2);
    C      = log(sexb-exb);
    eta    = axbeta-C;
    omega  = reshape(pgdraw(eta(:)),NT,J-1);
    %----------------------------------------------------------------------
    % draw beta
    m    = Xl'*(kappa+omega.*(C-anu));  %%%-q
    V    = omega'*xx;
    numc = sum(indexwd==1);
    invV = v*eye(numc,numc);
    for l=2:Lc
        indexl = Jind==l;
        numl   = sum(indexl);
        if numl>0
            % sample for indexwd>0
            V_l        = inv(Xind'*reshape(sum(V(indexl,:),1),K,K)*Xind+invV);
            m_l        = V_l*sum(m(:,indexl),2);
            beta_l     = m_l+chol(V_l)'*randn(numc,1);
            betacd(l,indexwd==1) = beta_l'; 
            % sample for indexwd==0
            betacd(l,indexwd==0) = sqrt(v)*randn(1,sum(indexwd==0));
        else
            % sample from prior
            betacd(l,indexwd>=0) = sqrt(v)*randn(1,sum(indexwd>=0));
        end
    end
    betac = betacd(:,wD);
    beta  = betac(Jind,:);
    % ---------------------------------------------------------------------
    % draw Jind
    Fc                  = MNLllc(Y2,X,anu,beta',betac');
    [Jind,Pc,~,lambdac] = sampleInd(Fc,Pc,lambdac,priorc);
    beta                = betac(Jind,:);
    % ---------------------------------------------------------------------
    % draw Dind
    betad               = betacd(Jind,Kw+1:end);
    Fd                  = MNLlld(Y2,X,anu,beta',betad',Kw);
    [Dind,Pd,~,lambdad] = sampleInd(Fd,Pd,lambdad,priord);
    [Xl,indexwd,Xind]   = clusterX(Xw,Xd,Dind,Ld);
    wD                  = [(1:Kw) (Kw+Dind')];
    beta                = betacd(Jind,wD);
    % ---------------------------------------------------------------------
    % draw alpha
    xbeta = X*beta';
    V     = 1./(sum(omega)+v);
    m     = V.*sum(kappa+omega.*(C-xbeta-nuN));
    alpha = m+sqrt(V).*randn(1,J-1);
    % ---------------------------------------------------------------------
    % draw nu, q, Q
    y     = ((kappa+omega.*(C-xbeta-alpha))./sqrt(omega))';
    x     = (W.*sqrt(omega))';
    [nu,Q,Lambda,invpsi,q] = sampleRE(y,x,Q,Lambda,invpsi,J-1,N,T,a0,b0,Bmu,q); 
    nuT   = repelem(nu',T,1);
    nuN   = W.*nuT;
    % ---------------------------------------------------------------------
    % save
    if iter>burnin && mod(iter,thin)==0
        saveIndex            = saveIndex+1;
        asave(:,saveIndex)   = alpha';
        bsave(:,:,saveIndex) = beta;
        Csave(:,saveIndex)   = Jind;
        Dsave(:,saveIndex)   = Dind;
        Qsave(:,:,saveIndex) = Q;
        qsave(:,saveIndex)   = q;
        nsave(:,:,saveIndex) = nu';
    end
    % ---------------------------------------------------------------------
    % display progress
    if mod(iter,100)==0
        disp([num2str(iter) ' iterations of a total of ' num2str(nGibbs)...
            ' iterations in ' num2str(toc(startGibbs)) ' seconds.']);
    end
    % ---------------------------------------------------------------------
end
timeLoop=toc(startGibbs);
save('Mixed','-v7.3');
%--------------------------------------------------------------------------