function [alphadgp,betadgp,qdgp,Qdgp,nudgp,Xw,Xd,X,Y,W,Yout,Xout,Wout] = generate_data(Nin)
% -------------------------------------------------------------------------
% dimensions
Kw       = 4;
Kd       = 10;
K        = Kw+Kd;
N        = 10000+Nin; 
T        = 5;
NT       = N*T;
Nin      = Nin*T;
J        = 50;
% -------------------------------------------------------------------------
% parameters
alphadgp = 2*[0;rand(J-1,1)-0.5];
betadgp  = [zeros(K,J/5) [repelem(ones(Kw,1),1,4*J/5);...
            repelem(repelem([0 0 0 0;-2 -1 1 2; -2 1 -1 2; 2 -1 1 -2; 2 1 -1 -2],1,J/5),Kd/5,1)]];
qdgp     = randn(J-1,1);
Ldgp     = (0:(1/(J-1)):(1-(1/(J-1))))';
%Ddgp     = zeros(J-1,1);
Qdgp     = Ldgp*Ldgp'+diag(1-diag(Ldgp*Ldgp'));
% -------------------------------------------------------------------------
% generate X
Xw       = randn(NT,Kw);
p        = exp(Xw(:,1))./(1+exp(Xw(:,1)));
Xdall    = mnrnd(1,[(p/(Kd))*ones(1,Kd) 1-p]);
Xd       = Xdall(:,1:end-1);
X        = [Xw Xd];
% generate random effects
W     = randn(NT,J-1); 
nudgp = [zeros(N,1) (qdgp+chol(Qdgp)'*randn(J-1,N))']; 
% generate Y
XB    = [zeros(NT,1) W].*repelem(nudgp,T,1)+X*betadgp+alphadgp';
expXB = exp(XB);
prob  = expXB./repmat(sum(expXB,2),1,J);
Y     = mnrnd(1,prob);
% -------------------------------------------------------------------------
Yout = Y(Nin+1:end,:);
Xout = X(Nin+1:end,:);
Wout = W(Nin+1:end,:);
Y    = Y(1:Nin,:);
X    = X(1:Nin,:);
W    = W(1:Nin,:);
Xw    = Xw(1:Nin,:);
Xd    = Xd(1:Nin,:);
% -------------------------------------------------------------------------
end