function [alphaj,p,C,beta] = priordraw( prior,J,Lj,K)
% draw unobservables from the prior
alphaj       = gamrnd(prior.eta1,1/prior.eta2);
p            = stick(alphaj,Lj);
C            = zeros(J,1);
for j=1:J
    C(j,1)  = 1+sum(rand>=cumsum(p));
end
if nargin>3
    beta         = zeros(Lj,K);
beta(2:Lj,:) = prior.sigmab*randn(Lj-1,K);
end
end

function p = stick(alpha,L)
p     = zeros(L,1);
V     = zeros(L-1,1);
for i=1:L-1
    V(i,1)     = betarnd(1,alpha);
    if i==1
        p(i,1) = V(i,1);
    else
        p(i,1) = prod((1-V(1:i-1,1)))*V(i,1);
    end
end
p(L,:)  = 1-sum(p(1:L-1,:));
end


% 
% function [alphaj,p,C,beta] = priordraw( prior,J,Lj,K)
% % draw unobservables from the prior
% alphaj       = prior.eta1/prior.eta2;
% p            = (1/Lj)*ones(Lj,1);
% C            = [1;2*ones(J-1,1)];%randi(Lj,J,1); %
% end



