function [Sigma,Lambda,invpsi] = sampleFactor(X,Lambda,invpsi,J,N,a0,b0)
% -------------------------------------------------------------------------
% x_i = Lambda*phi_i+eps_i, eps_i~N(0,Psi)
% X      : J*N
% Lambda : J*1
% invpsi : J*J
% -------------------------------------------------------------------------
% [J,N] = size(X);
% 
% % prior
% a0 = 4*ones(J,1);
% b0 = 4*ones(J,1);
% L0 = ones(J);
% -------------------------------------------------------------------------
LambdainvPsi = (Lambda.*invpsi)';
F            = 1/(LambdainvPsi*Lambda+1);
f            = (F*LambdainvPsi)*X;
Phi          = f+sqrt(F)*randn(1,N);
% sample Lambda
L            = 1./(sum(Phi.^2)*invpsi+1);
l            = L.*(invpsi.*(X*Phi'));
Lambda       = l+sqrt(L).*randn(J,1); %Lambda(1)=sqrt(.5);
% sample Psi
a            = a0+N;
eb           = X-Lambda*Phi;
b            = b0+sum(eb.^2,2);
invpsi       = randg(a)./b;%gamrnd(a, 1./b);
%invpsi(1)=2;
Sigma        = Lambda*Lambda'+diag(1./invpsi);
% -------------------------------------------------------------------------
% v         = J+2;
% S         = 2*(v-J-1)*eye(J); 
% Q         = drawIWishart(v+N,S+eps*eps');
% -------------------------------------------------------------------------
% p141 Greenberg
end