function [alpha,Q,Lambda,invpsi,q] = sampleRE(y,x,Q,Lambda,invpsi,J,N,T,a0,b0,Bmu,q)
%--------------------------------------------------------------------------
% draw alpha
Y        = reshape(y,J,T,N);
X        = reshape(x,J,T,N);
alpha    = zeros(J,N);
invQq    = Q\q;
A        = reshape(sum(X.*Y,2),J,N)+invQq;
B        = reshape(sum(X.^2,2),J,N);
B        = 1./(invpsi+B);
R2       = sqrt(B).*randn(J,N);
Lambda2  = Lambda.*invpsi/sqrt(1+Lambda'*diag(invpsi)*Lambda);
for i=1:N
    Ci         = B(:,i);
    Ai         = Ci.*Lambda2;
    Ai2        = Ai/sqrt(1-Ai'*Lambda2);
    Aii        = A(:,i);
    bbar       = Ci.*Aii+Ai2*(Ai2'*Aii);
    R1         = Ai2*randn;
    re2        = bbar+R1+R2(:,i);
    alpha(:,i) = re2;
end
%--------------------------------------------------------------------------
% draw q
Bbar    = (N+1/Bmu);
bbar    = sum(alpha,2)/Bbar;
q       = bbar+sqrt(1/Bbar)*chol(Q)'*randn(J,1);
% draw Q
%--------------------------------------------------------------------------
eps               = alpha-q;
[Q,Lambda,invpsi] = sampleFactor(eps,Lambda,invpsi,J,N,a0,b0);
%--------------------------------------------------------------------------
end